(function ($) {

Drupal.behaviors.imageeditor = {};
Drupal.behaviors.imageeditor.attach = function(context, settings) {
  //$.extend(true, Drupal.settings, settings);
  
  var $imageeditor_divs_existing = $('.imageeditor.imageeditor-existing', context);
  $imageeditor_divs_existing.find('div.pixlr-editor').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.editor_url,
        'image': url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials
      });
    }
  );
  $imageeditor_divs_existing.find('div.pixlr-express').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.express_url,
        'image': url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials
      });
    }
  );
  $imageeditor_divs_existing.find('div.picnik').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.picnik.url,
        '_apikey': Drupal.settings.imageeditor.picnik['api_key'],
        '_import': url,
        '_export': Drupal.settings.imageeditor.picnik['export'] + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        '_export_agent': 'browser',
        '_export_method': 'GET',
        '_export_title': 'Save to ' + Drupal.settings.imageeditor.site_name,
        '_host_name': Drupal.settings.imageeditor.site_name,
        '_replace': 'ask', //Picnik will ask: replace an image or create a new one
        '_imageid': field_name + '_' + delta,
        '_original_thumb': $(this).parent().parent().parent().find('.imagefield-preview').find('img').attr('src'),
        '_close_target': Drupal.settings.imageeditor.picnik.exit,
        //'_expand_button': 'true' //adds Expand button and calls onPicknikExpand function
        '_locale': Drupal.settings.imageeditor.picnik.loc
      });
    }
  );
  $imageeditor_divs_existing.find('div.aviary-feather').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor_first_run = 'yes';
      if (_featherLoaded) {
        aviaryeditor($(this).parent().parent().parent().parent().find('.image-preview').find('img').attr('id', field_name + '*' + delta).attr('id'), url);
      }
    }
  );
  $imageeditor_divs_existing.find('div.aviary-phoenix').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.aviary_phoenix.url,
        'loadurl': url,
        'posturl': Drupal.settings.imageeditor.aviary_phoenix.posturl + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'postagent': 'client',
        'exiturl': Drupal.settings.imageeditor.aviary_phoenix.exiturl,
        'exiturltarget': 'replace',
        'sitename': Drupal.settings.imageeditor.site_name
      });
    }
  );
  $imageeditor_divs_existing.find('div.aviary-raven').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.aviary_raven.url,
        'loadurl': url,
        'posturl': Drupal.settings.imageeditor.aviary_raven.posturl + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'postagent': 'client',
        'exiturl': Drupal.settings.imageeditor.aviary_raven.exiturl,
        'exiturltarget': 'replace',
        'sitename': Drupal.settings.imageeditor.site_name
      });
    }
  );
  $imageeditor_divs_existing.find('div.aviary-peacock').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.aviary_peacock.url,
        'loadurl': url,
        'posturl': Drupal.settings.imageeditor.aviary_peacock.posturl + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'postagent': 'client',
        'exiturl': Drupal.settings.imageeditor.aviary_peacock.exiturl,
        'exiturltarget': 'replace',
        'sitename': Drupal.settings.imageeditor.site_name
      });
    }
  );
  $imageeditor_divs_existing.find('div.aviary-falcon').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.aviary_falcon.url,
        'loadurl': url,
        'posturl': Drupal.settings.imageeditor.aviary_falcon.posturl + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'postagent': 'client',
        'exiturl': Drupal.settings.imageeditor.aviary_falcon.exiturl,
        'exiturltarget': 'replace',
        'sitename': Drupal.settings.imageeditor.site_name
      });
    }
  );
  $imageeditor_divs_existing.find('div.sumopaint').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.sumopaint.url,
        'key': Drupal.settings.imageeditor.sumopaint['api_key'],
        'url': url,
        'service': 'Save to ' + Drupal.settings.imageeditor.site_name,
        'target': Drupal.settings.imageeditor.sumopaint.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1'
        //'opt': 'test',
      });
    }
  );
  $imageeditor_divs_existing.find('div.fotoflexer').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.fotoflexer.url,
        'ff_image_url': url,
        'ff_callback_url': Drupal.settings.imageeditor.fotoflexer.callback_url + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'ff_cancel_url': Drupal.settings.imageeditor.fotoflexer.cancel_url,
        'ff_lang': Drupal.settings.imageeditor.fotoflexer.lang
      });
    }
  );
  $imageeditor_divs_existing.find('div.flauntr-styler').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.flauntr_styler.url,
        'app': 'styler',
        'url': url
      });
    }
  );
  $imageeditor_divs_existing.find('div.pixlr-upload').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var $url = $(this).parent().parent().find('.url');
      var filepath = $(this).parent().parent().find('.filepath').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.imageeditor.pixlr_upload.upload,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': filepath},
        success: function(data) {$url.attr('value', data);},
        error: function(msg) {alert("Failed uploading to Pixlr: " + msg);}
      });
    }
  );
  $imageeditor_divs_existing.find('div.immio-upload').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var $url = $(this).parent().parent().find('.url');
      var filepath = $(this).parent().parent().find('.filepath').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.imageeditor.immio_upload.upload,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': filepath},
        success: function(data) {$url.attr('value', data);},
        error: function(msg) {alert("Failed uploading to imm.io: " + msg);}
      });
    }
  );
  $imageeditor_divs_existing.find('div.imageshack-upload').click(
      function() {
        var field_name = $(this).parent().parent().find('.field-name').attr('value');
        var delta = $(this).parent().parent().find('.delta').attr('value');
        var $url = $(this).parent().parent().find('.url');
        var filepath = $(this).parent().parent().find('.filepath').attr('value');
        $.ajax({
          type: 'GET',
          url: Drupal.settings.imageeditor.imageshack_upload.upload,
          async: false, // explicitly need the user to wait while we load...
          data: {'filepath': filepath},
          success: function(data) {$url.attr('value', data);},
          error: function(msg) {alert("Failed uploading to Imageshack: " + msg);}
        });
      }
    );
  
  //to show as overlay over the image preview
  $('div.image-preview', context).each(
    function(index) {
      var field_name = $(this).find('.imageeditor').find('.field-name').attr('value');
      if (typeof(Drupal.settings.imageeditor[field_name]['imageeditor_icons_position']) != 'undefined') {
        if (Drupal.settings.imageeditor[field_name]['imageeditor_icons_position'] == 1) {
          $(this).css({'position': 'relative', 'width': '100px'}).hover(
            function() {
              $(this).find('.imageeditor').css({'position': 'absolute', 'top': 0}).show();
            },
            function() {
              $(this).find('.imageeditor').hide();
            }
          ).find('.imageeditor').hide();
        }
      }
    }
  );
  
  var $imageeditor_divs_new = $('.imageeditor.imageeditor-new', context);
  $imageeditor_divs_new.find('div.pixlr-editor').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.editor_url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials
      });
    }
  );
  $imageeditor_divs_new.find('div.pixlr-express').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.express_url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials
      });
    }
  );
  $imageeditor_divs_new.find('div.picnik').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.picnik.url,
        '_apikey': Drupal.settings.imageeditor.picnik['api_key'],
        '_export': Drupal.settings.imageeditor.picnik['export'] + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        '_export_agent': 'browser',
        '_export_method': 'GET',
        '_export_title': 'Save to ' + Drupal.settings.imageeditor.site_name,
        '_host_name': Drupal.settings.imageeditor.site_name,
        '_close_target': Drupal.settings.imageeditor.picnik.exit,
        //'_expand_button': 'true' //adds Expand button and calls onPicknikExpand function
        '_locale': Drupal.settings.imageeditor.picnik.loc
      });
    }
  );
  $imageeditor_divs_new.find('div.sumopaint').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.sumopaint.url,
        'key': Drupal.settings.imageeditor.sumopaint['api_key'],
        'service': 'Save to ' + Drupal.settings.imageeditor.site_name,
        'target': Drupal.settings.imageeditor.sumopaint.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1'
        //'opt': 'test',
      });
    }
  );
  $imageeditor_divs_new.find('div.fotoflexer').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.fotoflexer.url,
        'ff_callback_url': Drupal.settings.imageeditor.fotoflexer.callback_url + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'ff_cancel_url': Drupal.settings.imageeditor.fotoflexer.cancel_url,
        'ff_lang': Drupal.settings.imageeditor.fotoflexer.lang
      });
    }
  );
  $imageeditor_divs_new.find('div.flauntr-styler').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      Drupal.imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.flauntr_styler.url,
        'app': 'styler'
      });
    }
  );
};

var _featherLoaded = false;
Feather_OnLoad = function() {
    _featherLoaded = true;
};

Feather_OnSave = function(imageId, newurl) {
  imageeditor_url = newurl;
  if (imageeditor_first_run != 'no') {
    var tmp = imageId.split("*");
    imageeditor_field_name = tmp[0];
    imageeditor_delta = tmp[1];
    imageeditor_edit_field_name = 'edit-' + tmp[0].replace(/_/g, '-');
    if (Drupal.settings.imageeditor[imageeditor_field_name]['imageeditor_replace']) {
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-' + imageeditor_delta + '-remove-button"]').mousedown();
    }
    else {
      //$('input[name="' + imageeditor_field_name + '_add_more"]').mousedown();
    }
    imageeditor_first_run = 'no';
  }
};

Feather_OnClose = function() {
  if ((typeof(imageeditor_field_name) != 'undefined') && (imageeditor_field_name != 'undefined')) {
    if (Drupal.settings.imageeditor[imageeditor_field_name]['imageeditor_replace']) {
      $('a[id^="' + imageeditor_edit_field_name + '-"][id$="-remote-source"]:first').click();
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-url"]:first').val(imageeditor_url);
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-transfer"]:first').mousedown();
    }
    else {
      $('a[id^="' + imageeditor_edit_field_name + '-"][id$="-remote-source"]:first').click();
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-url"]:first').val(imageeditor_url);
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-transfer"]:first').mousedown();
    }
    imageeditor_url = 'undefined';
    imageeditor_field_name = 'undefined';
    imageeditor_delta = 'undefined';
    imageeditor_edit_field_name = 'undefined';
    imageeditor_first_run = 'undefined';
  }
};

if (typeof(Drupal.imageeditor) == 'undefined') {
Drupal.imageeditor = function() {
  function windowSize() {
    var w = 0, h = 0;
    if(!(document.documentElement.clientWidth == 0)) {
      w = document.documentElement.clientWidth;
      h = document.documentElement.clientHeight;
    }
    else {
      w = document.body.clientWidth;
      h = document.body.clientHeight;
    }
    return {width:w,height:h};
  }
  function buildUrl(opt) {
    var url = opt.imageeditor_url;
    var first_attr = 'yes';
    for (var attribute in opt) {
      if(attribute !== 'imageeditor_url') {
        if (first_attr == 'yes') {
          url += "?"+ attribute +"="+ escape(opt[attribute]);
          first_attr = 'no';
        }
        else {
          url += "&"+ attribute +"="+ escape(opt[attribute]);
        }
      }
    }
    return url;
  }
  var bo = {
    ie: window.ActiveXObject,
    ie6: window.ActiveXObject && (document.implementation != null) && (document.implementation.hasFeature != null) && (window.XMLHttpRequest == null),
    quirks: document.compatMode==='BackCompat'
  };
  return {
    overlay: {
      show: function(options) {
        var iframe = document.createElement('iframe'),
        div = document.createElement('div'),
        idiv = document.createElement('div'),
        div_close = document.createElement('div');
        iframe.className = 'imageeditor-iframe';
        div.className = 'imageeditor-external';
        idiv.className = 'imageeditor-internal';
        div_close.className = 'imageeditor-close';
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          var size = windowSize();
          div.style.position = 'absolute';
          div.style.width = size.width + 'px';
          div.style.height = size.height + 'px';
          div.style.setExpression('top', "(t=document.documentElement.scrollTop||document.body.scrollTop)+'px'");
          div.style.setExpression('left', "(l=document.documentElement.scrollLeft||document.body.scrollLeft)+'px'");
        }
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          idiv.style.position = 'absolute';
          idiv.style.setExpression('top', "40+((t=document.documentElement.scrollTop||document.body.scrollTop))+'px'");
          idiv.style.setExpression('left', "40+((l=document.documentElement.scrollLeft||document.body.scrollLeft))+'px'");
        }
        
        document.body.appendChild(div);
        document.body.appendChild(idiv);
        document.body.appendChild(div_close);
        
        iframe.style.width = (div.offsetWidth - 80) +'px';
        iframe.style.height = (div.offsetHeight - 80) +'px';
        iframe.src = buildUrl(options);
        
        idiv.appendChild(iframe);
        
        $('div.imageeditor-close').click(
          function() {
            Drupal.imageeditor.overlay.hide();
          }
        );
      },
      hide: function() {
        $('.imageeditor-external').remove();
        $('.imageeditor-internal').remove();
        $('.imageeditor-close').remove();
      }
    },
    popup: {
      show: function(options) {
        popup_window = window.open(buildUrl(options), 'imageeditor', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no,channelmode=yes,fullscreen=yes');
        popup_window.focus();
      }
    }
  };
}();
}

})(jQuery);
